#!/usr/bin/perl
use URI::Escape;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

my $host=$ENV{'SERVER_NAME'};
my $scripts='/cgi-bin';
chdir '/var/www/user';

%month=(Jan=>12,Feb=>11,Mar=>10,Apr=>9,May=>8,Jun=>7,Jul=>6,Aug=>5,Sep=>4,Oct=>3,Nov=>2,Dec=>12);

$meth=$ENV{'REQUEST_METHOD'} if defined($ENV{'REQUEST_METHOD'});
$content_length = defined($ENV{'CONTENT_LENGTH'}) ? $ENV{'CONTENT_LENGTH'} : 0;
if($meth eq 'POST'){read(\*STDIN,$query,$content_length,0)}
else{$query = $ENV{'QUERY_STRING'};}

@pairs = split(/[&;]/,$query);
my($param,$value);
%refs=();
foreach (@pairs)
	{
	($param,$value) = split('=',$_,2);
	$value = '' unless defined $value;
	$refs->{$param}=uri_unescape($value);
	}
$state=$refs->{state}||'list';

%cookie=();
@nvpairs=split(/; /, $ENV{'HTTP_COOKIE'});
foreach $pair (@nvpairs)
{
	($name, $value) = split(/=/, $pair);
	$cookie{$name} = $value;
}

badlogon("missing logon cookie") unless ($cookie{user}&&$cookie{cert});
$user=$cookie{user};
#print "Content-type: text/html\n\n";
badlogon("can't cd $user") unless (chdir $user);
badlogon("can't open session file") unless(open SESS,"session.txt");
$cert=<SESS>;chop $cert;
$ip=<SESS>;chop $ip;
close SESS;
badlogon("bad ip or cookie") unless($cert eq $cookie{cert}&&$ip eq $ENV{'REMOTE_ADDR'});
#cookie and IP address match, check state
@uentries=<*.jrn>; #unsorted entries
$s=0;
for (@uentries){$s+= -s $_;}
if($s>512000){$toobig=1;}

if ($state eq 'list')
{
print "Content-type: text/html\n\n";
print <<"END";
<HTML><head>
<style>
body {FONT-FAMILY:Verdana,Arial,Helvetica,sans-serif;}
a {color:009bff;}
</style>
</head>
<body bgcolor=black text=yellow>
<div style=font-size:20px;text-align:center;>
Journal entries for $user
<center>
<div style=width:700px;font-size:15px;text-align:justify;line-height:20px;>
<br>
<a href="$scripts/at.cgi?node=journal">Back</a> to main journal page<br>
END
	@entries=sort { monthval($a) <=> monthval($b)  ||substr($b,8) cmp substr($a,8)} @uentries;
	if($toobig){print 'Journal full<p><pre>';}
	else{print "<a href=\"$scripts/journal.cgi?state=new\">Compose new entry</a><p><pre>";}
	$n=0;
	for (@entries)
	{
		$_=~/^(.+)\./;
		print"<a href=\"$scripts/journal.cgi?state=load&num=$n\">$1</a>\n";
		$n++;
	}
	if($n==0){print "Journal empty\n";}
	print '</pre></div></center></div>';
	print "<p><br>$s/512000 bytes";
	print '</body></HTML>';
}
elsif ($state eq 'new')
{
badlogon("journal full") if ($toobig);
print "Content-type: text/html\n\n";
open CM, "/var/www/journal/compose.html";
while (<CM>){print;}
close CM;
}
elsif ($state eq 'load')
{
@entries=sort { monthval($a) <=> monthval($b)  ||substr($b,8) cmp substr($a,8)} @uentries;
open JF,$entries[$refs->{num}];
undef $/;
$jf=<JF>;
close JF;
print "Content-type: text/html\n\n";
open DF,"/var/www/journal/decode.html";
while(<DF>){print;}
close DF;
print $jf;
print '</textarea></td></tr></table></form></center>';
print "<a href=\"$scripts/journal.cgi?state=list\">Back to list</a></body></HTML>";
}
elsif ($state eq 'post')
{
badlogon() if ($toobig);
if(defined($refs->{file}))
	{
	if ((length $refs->{file})>50000)
		{
		print "Content-type: text/html\n\n";
		print "<html><body>Encoded file too large</body></html>";
		exit;
		}
	#size limit = 500k of encoded data (250k of journal data, 12.5 max-length entries)
	@entries=<*.jrn>;
	$s=0;
	for(@entries){$s+= -s $_;}
	if($s>512000)
		{
		print "Content-type: text/html\n\n";
		print "<html><body>Journal exceeds maximum size</body></html>";
		exit;
		}

	$now=localtime;
	open PO,"> $now.jrn";
	print PO $refs->{file};
	close PO;
	print "Location: http://$host$scripts/journal.cgi?state=list\n\n";
	}
else
	{
	print "Content-type: text/html\n\n";
	print "<html><body>File submission failed</body></html>";
	}
}
else
{
	print "Content-type: text/html\n\n";
	print "<html><body>Not logged in<p>Invalid state</body></html>";
}

exit;

sub badlogon()
{
    my $reason=shift;
print "Content-type: text/html\n\n";
print "<html><body>Not logged in<br>$reason</body></html>";
exit;
}

sub monthval()
{
$in=shift;
$mon=substr($in,4,3);
$ans=$month{$mon};
return $ans;
}
