#!/usr/bin/perl
use strict;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

my $t;
my $srcdir=shift;
chdir '/var/www/'.$srcdir;
my @uentries=<*.blg>;
print <<"EOF";
<script>
function togglebig(elem)
{
if (elem.isbig)
	{
	elem.style.fontSize = "0.3em";
	elem.style.lineHeight = "6px";
	elem.isbig=0;
	}
else
	{
	elem.style.lineHeight = "20px";
	elem.style.fontSize = "1em";
	elem.isbig=1;
	}
}
</script>
<style>
.tiny:first-line {font-size:16px;line-height:20px;}
.tiny {font-size:0.3em;text-align:justify;line-height:6px;}
</style>
EOF

for(reverse sort @uentries)
{
  open (FILE,$_);
print '<hr><div class=tiny onclick=togglebig(this)>';
  while (<FILE>)
  {
    $_=~/^([#%!]?)(.*)\n?$/;
    $t=$2||'<br>';
    if ($1)
	{
	if($1 eq '#'){print"<p>$t<br>\n";}
	elsif($1 eq '%'){print"<div class=hed>$t</div>\n";}
	elsif($1 eq '!'){print"<span class=bld>$t</span>\n";}
	}
    else{print"$t\n";}
  }
print '</div>';
  close (FILE);
}
if(@uentries){print '<hr>';}
