#!/usr/bin/perl
use strict;

#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

my $host=$ENV{'SERVER_NAME'};
my $atcgi='/cgi-bin/at.cgi';
my $query = $ENV{'QUERY_STRING'} || '';
my %refs=();
my($param,$value);
my @pairs = split(/[&;]/,$query);
foreach (@pairs)
	{
	($param,$value) = split('=',$_,2);
	$value = '' unless defined $value;
	$refs{$param}=$value;
	}
my $css = $refs{css} || '';
my $catch=$refs{catch} || '';
$catch=~/([a-z]+)\.([a-z]+)/;
my $node=$1 || 'home';
my $file=$2 || 'index';

if($css ne 'cq' and $css ne 'user' and $css ne 'standard' and $css ne 'yahoo' and $css ne 'nausicaa')
{print "Content-type: text/html\n\nInvalid CSS selection";exit;}
print "Set-Cookie: css=$css; path=/; expires=Friday, 01-Jan-2010 00:00:00 GMT\n";
print "Location: http://$host$atcgi?node=$node&file=$file\n\n";
