#!/usr/bin/perl
use strict;
#    Copyright 2002 Curtis Autery
#
#    This file is part of atengine.
#
#    atengine is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    atengine is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with atengine; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# This is a simple redirect script that calls
# at.cgi with the appropriate node name.
# Node name defaults to 'home', but if the
# HTTP_HOST value is a recognized cname,
# then the node name is altered.

# Modify @cnames and $host below as appropriate

my @cnames=('journal','www');
my $host=$ENV{'SERVER_NAME'};
my $atcgi='/cgi-bin/at.cgi';
my $url=$ENV{'HTTP_HOST'};
my $node='home';
my $tmp;
for (@cnames)
{
    $tmp=$_;
    if($url=~/^$tmp\.$host/){$node=$tmp;}
}

print "Content-type: text/html\n";
print "Location: http://$host$atcgi?node=$node\n\n";
